#ifndef _fencer_camera_h
#define _fencer_camera_h

#include "vmath.h"
#include <SDL2/SDL_rect.h>

struct Camera {
    Vector centre;
    float width;
};

typedef struct Camera Camera;

// current world location of camera
extern Camera g_camera;

extern void camera_init();
// generate a screen-space rectangle that is exactly 1x1 in world units.
// With it's centre on the world origin.
extern SDL_FRect camera_calculate_world_unit_rect(Camera* self);
extern SDL_FRect camera_screen_to_world_space(Camera* self, SDL_FRect* camera_space);
extern SDL_FRect camera_world_to_screen_space(Camera* self, SDL_FRect* world_space);

#endif // !_fencer_camera_h
