#ifndef _fencer_sprite_h
#define _fencer_sprite_h

#include "vmath.h"
#include "transform.h"
#include "spritesheet.h"
#include <SDL2/SDL_render.h>
#include <SDL2/SDL_rect.h>

// Forward declaration of the private sprite struct
typedef struct Sprite Sprite;

extern Sprite* sprite_from_spritesheet(Spritesheet* sheet);
extern void sprite_destroy(Sprite* sprite);
extern void sprite_draw(Sprite* self, Transform transform);

extern void sprite_set_position(Sprite* self, Vector position);
extern void sprite_translate(Sprite* self, Vector delta_position);
extern void sprite_set_scale(Sprite* self, Vector scale);
extern void sprite_scale(Sprite* self, Vector scale);
extern void sprite_set_rotation(Sprite* self, float rotation);
extern void sprite_rotate(Sprite* self, float delta_rotation);
extern void sprite_set_origin(Sprite* self, Vector origin);

#endif // !_fencer_sprite_h
